import { NS } from "@ns";
import { getControllerState } from "/lib/types-and-constants";

export async function main(ns : NS) : Promise<void> {
  const [script] = ns.args

  const datafileState = getControllerState(ns)
  const adminServers = datafileState.knownServers.filter(s => s.hasAdminRights)

  for(const server of adminServers) {
    const processes = ns.ps(server.hostname)

    for (const process of processes) {
      if (process.filename === script)
        ns.kill(process.pid)
    }
  }
}
