import { NS } from "@ns";
import { getControllerState } from "/lib/types-and-constants";

export function printStatus(ns : NS) {
  const currentHackingLevel = ns.getHackingLevel()
  const {knownServers} = getControllerState(ns)

  const numServers = knownServers.length
  const rootedServers = knownServers.filter(server => server.hasAdminRights).length
  const backdooredServers = knownServers.filter(server => server.backdoorInstalled).length
  const hackableServers = knownServers.filter(server => server.requiredHackingSkill && server.requiredHackingSkill <= currentHackingLevel).length

  ns.print(`INFO: Current topology stats:\n`)
  ns.print(` - known:      ${numServers}`)
  ns.print(` - hackable:   ${hackableServers}`)
  ns.print(` - rooted:     ${rootedServers}`)
  ns.print(` - backdoored: ${backdooredServers}`)
}
