import { NS, Server } from "@ns"

const datafile = "/data-state.txt"

interface ControllerState {
  knownServers: Server[],
  assignments: {
    [droneHostname: string]: {
      targetHostname: string,
      attackMode: 'grow' | 'hack' | 'weaken',
    }
  },
  previousAssignments: {
    [droneHostname: string]: {
      targetHostname: string,
      attackMode: 'grow' | 'hack' | 'weaken',
    }
  }
}

export function getControllerState(ns : NS) : ControllerState {
  return JSON.parse(ns.read(datafile) || `{
    "knownServers": [],
    "assignments": {},
    "previousAssignments": {}
  }`)
}

export function setControllerState(ns : NS, state : ControllerState) {
  ns.write(datafile, JSON.stringify(state), 'w')
}

