import { NS } from '@ns'

import ReactLib from 'react';
declare const React: typeof ReactLib;

import Styles, {example} from '/styles'

const { useState } = React

export async function main(ns : NS) : Promise<void> {
  const [{pid}] = ns.ps()
  let resolve : Function

  const scriptPromise = new Promise(res => { resolve = res })

  ns.printRaw(
    <>
      <TestReactComponent pid={pid} onClose={() => resolve()}/>
    </>
  )

  scriptPromise.then(() => {
    ns.closeTail(pid)
  })

  ns.tail(pid)

  await scriptPromise
}

function TestReactComponent({pid, onClose} : {pid: number, onClose: Function}) {
  const [value, setValue] = useState(0)
  return (
    <>
      <Styles/>
      <p>Script PID is {pid}</p>
      <p className={example.someClass}>The current value is {value}</p>
      <button onClick={() => setValue(value + 1)}>Increment</button>
      <button onClick={() => setValue(value - 1)}>Decrement</button>
      <button onClick={() => onClose()}>Close</button>
    </>
  )
}


