import { NS } from "@ns";
import { getControllerState } from "/lib/types-and-constants";

export async function main(ns : NS) : Promise<void> {
  const {knownServers} = getControllerState(ns)
  const playerHackingSkill = ns.getHackingLevel()

  for (const server of knownServers) {
    if(!server.hasAdminRights || server.hostname === 'home')
      continue

    if(server.requiredHackingSkill > playerHackingSkill)
      continue

    ns.scp('auto-hack.js', server.hostname)
    const ramCost = ns.getScriptRam('auto-hack.js')
    const ramAvail = server.maxRam - server.ramUsed
    const numThreads = Math.floor(ramAvail / ramCost)

    if (numThreads < 1)
      continue

    ns.exec('auto-hack.js', server.hostname, numThreads)
  }
  await ns.sleep(10000)
}
